VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "PaintEffects"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private m_hpalHalftone As Long
Private Declare Function DrawIcon Lib "user32" (ByVal hdc As Long, _
     ByVal x As Long, ByVal y As Long, _
     ByVal hIcon As Long) As Long
Private Declare Function CreateSolidBrush Lib "GDI32" _
     (ByVal crColor As Long) As Long
Private Declare Function BitBlt Lib "GDI32" (ByVal hDestDC As Long, _
     ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, _
     ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, _
     ByVal YSrc As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkColor Lib "GDI32" (ByVal hdc As Long, _
     ByVal crColor As Long) As Long
Private Declare Function CreateCompatibleDC Lib "GDI32" _
     (ByVal hdc As Long) As Long
Private Declare Function DeleteDC Lib "GDI32" _
     (ByVal hdc As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, _
     ByVal hdc As Long) As Integer
Private Declare Function CreateCompatibleBitmap Lib "GDI32" _
     (ByVal hdc As Long, ByVal nWidth As Long, _
     ByVal nHeight As Long) As Long
Private Declare Function SelectObject Lib "GDI32" (ByVal hdc As Long, _
     ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function SetTextColor Lib "GDI32" (ByVal hdc As Long, _
     ByVal crColor As Long) As Long
Private Declare Function CreateBitmap Lib "GDI32" (ByVal nWidth As Long, _
     ByVal nHeight As Long, ByVal nPlanes As Long, _
     ByVal nBitCount As Long, lpBits As Any) As Long
Private Declare Function GetBkColor Lib "GDI32" _
     (ByVal hdc As Long) As Long
Private Declare Function GetTextColor Lib "GDI32" _
     (ByVal hdc As Long) As Long
Private Declare Function SelectPalette Lib "GDI32" (ByVal hdc As Long, _
     ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
Private Declare Function RealizePalette Lib "GDI32" _
     (ByVal hdc As Long) As Long
Private Declare Function CreateHalftonePalette Lib "GDI32" _
     (ByVal hdc As Long) As Long
Private Declare Function OleTranslateColor Lib "oleaut32.dll" _
     (ByVal lOleColor As Long, ByVal lHPalette As Long, _
     lColorRef As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, _
     lpRect As RECT, ByVal hBrush As Long) As Integer

Private Const DSna = &H220326 '0x00220326
Public Sub PaintTransparentDC(ByVal hdcDest As Long, _
               ByVal xDest As Long, _
               ByVal yDest As Long, _
               ByVal Width As Long, _
               ByVal Height As Long, _
               ByVal hdcSrc As Long, _
               ByVal XSrc As Long, _
               ByVal YSrc As Long, _
               ByVal clrMask As OLE_COLOR, _
               Optional ByVal hPal As Long = 0)

    Dim hdcMask As Long
    Dim hdcColor As Long
    Dim hbmMask As Long
    Dim hbmColor As Long
    Dim hbmColorOld As Long
    Dim hbmMaskOld As Long
    Dim hPalOld As Long
    Dim hdcScreen As Long
    Dim hdcScnBuffer As Long
    Dim hbmScnBuffer As Long
    Dim hbmScnBufferOld As Long
    Dim hPalBufferOld As Long
    Dim lMaskColor As Long
    hdcScreen = GetDC(0&)
    If hPal = 0 Then
        hPal = m_hpalHalftone
    End If
    OleTranslateColor clrMask, hPal, lMaskColor
    hbmScnBuffer = CreateCompatibleBitmap(hdcScreen, Width, Height)
    hdcScnBuffer = CreateCompatibleDC(hdcScreen)
    hbmScnBufferOld = SelectObject(hdcScnBuffer, hbmScnBuffer)
    hPalBufferOld = SelectPalette(hdcScnBuffer, hPal, True)
    RealizePalette hdcScnBuffer
    BitBlt hdcScnBuffer, 0, 0, Width, Height, hdcDest, xDest, _
        yDest, vbSrcCopy
    hbmColor = CreateCompatibleBitmap(hdcScreen, Width, Height)
    hbmMask = CreateBitmap(Width, Height, 1, 1, ByVal 0&)
    hdcColor = CreateCompatibleDC(hdcScreen)
    hbmColorOld = SelectObject(hdcColor, hbmColor)
    hPalOld = SelectPalette(hdcColor, hPal, True)
    RealizePalette hdcColor
    SetBkColor hdcColor, GetBkColor(hdcSrc)
    SetTextColor hdcColor, GetTextColor(hdcSrc)
    BitBlt hdcColor, 0, 0, Width, Height, hdcSrc, XSrc, _
    YSrc, vbSrcCopy
    hdcMask = CreateCompatibleDC(hdcScreen)
    hbmMaskOld = SelectObject(hdcMask, hbmMask)
    SetBkColor hdcColor, lMaskColor
    SetTextColor hdcColor, vbWhite
    BitBlt hdcMask, 0, 0, Width, Height, hdcColor, 0, 0, _
    vbSrcCopy
    
    SetTextColor hdcColor, vbBlack
    SetBkColor hdcColor, vbWhite
    BitBlt hdcColor, 0, 0, Width, Height, hdcMask, _
    0, 0, DSna
    BitBlt hdcScnBuffer, 0, 0, Width, Height, hdcMask, _
    0, 0, vbSrcAnd
    BitBlt hdcScnBuffer, 0, 0, Width, Height, hdcColor, _
        0, 0, vbSrcPaint
    BitBlt hdcDest, xDest, yDest, Width, Height, _
        hdcScnBuffer, 0, 0, vbSrcCopy
    DeleteObject SelectObject(hdcColor, hbmColorOld)
    SelectPalette hdcColor, hPalOld, True
    RealizePalette hdcColor
    DeleteDC hdcColor
    DeleteObject SelectObject(hdcScnBuffer, hbmScnBufferOld)
    SelectPalette hdcScnBuffer, hPalBufferOld, True
    RealizePalette hdcScnBuffer
    DeleteDC hdcScnBuffer
    DeleteObject SelectObject(hdcMask, hbmMaskOld)
    DeleteDC hdcMask
    ReleaseDC 0&, hdcScreen
End Sub
Public Sub PaintTransparentStdPic(ByVal hdcDest As Long, _
                ByVal xDest As Long, _
                ByVal yDest As Long, _
                ByVal Width As Long, _
                ByVal Height As Long, _
                ByVal picSource As Picture, _
                ByVal XSrc As Long, _
                ByVal YSrc As Long, _
                ByVal clrMask As OLE_COLOR, _
                Optional ByVal hPal As Long = 0)

    Dim hdcSrc As Long
    Dim hbmMemSrcOld As Long
    Dim hbmMemSrc As Long
    Dim udtRect As RECT
    Dim hbrMask As Long
    Dim lMaskColor As Long
    Dim hdcScreen As Long
    Dim hPalOld As Long
    
    If picSource Is Nothing Then GoTo _
        PaintTransparentStdPic_InvalidParam
        Select Case picSource.Type
        Case vbPicTypeBitmap
        hdcScreen = GetDC(0&)
    
            If hPal = 0 Then
                hPal = m_hpalHalftone
            End If
    
            hdcSrc = CreateCompatibleDC(hdcScreen)
            hbmMemSrcOld = SelectObject(hdcSrc, picSource.Handle)
            hPalOld = SelectPalette(hdcSrc, hPal, True)
            RealizePalette hdcSrc
    
            PaintTransparentDC hdcDest, xDest, yDest, _
                Width, Height, hdcSrc, XSrc, YSrc, clrMask, hPal
            SelectObject hdcSrc, hbmMemSrcOld
            SelectPalette hdcSrc, hPalOld, True
            RealizePalette hdcSrc
            DeleteDC hdcSrc
            ReleaseDC 0&, hdcScreen
        Case vbPicTypeIcon
    
            hdcScreen = GetDC(0&)
    
            If hPal = 0 Then
                hPal = m_hpalHalftone
            End If
            hdcSrc = CreateCompatibleDC(hdcScreen)
            hbmMemSrc = CreateCompatibleBitmap(hdcScreen, _
                Width, Height)
            hbmMemSrcOld = SelectObject(hdcSrc, hbmMemSrc)
            hPalOld = SelectPalette(hdcSrc, hPal, True)
            RealizePalette hdcSrc
    
            udtRect.Bottom = Height
            udtRect.Right = Width
            OleTranslateColor clrMask, 0&, lMaskColor
            hbrMask = CreateSolidBrush(lMaskColor)
            FillRect hdcSrc, udtRect, hbrMask
            DeleteObject hbrMask
            DrawIcon hdcSrc, 0, 0, picSource.Handle
    
            PaintTransparentDC hdcDest, xDest, yDest, Width, _
                Height, hdcSrc, 0, 0, lMaskColor, hPal            'Clean up
            DeleteObject SelectObject(hdcSrc, hbmMemSrcOld)
            SelectPalette hdcSrc, hPalOld, True
            RealizePalette hdcSrc
            DeleteDC hdcSrc
            ReleaseDC 0&, hdcScreen
            Case Else
            GoTo PaintTransparentStdPic_InvalidParam
            End Select
            Exit Sub
PaintTransparentStdPic_InvalidParam:
    Exit Sub
End Sub
